
{$mode objfpc}
{$modeswitch functionreferences}

Type 
    TMyProcedureType = reference to procedure(x,y : integer);

Procedure ExecProcedure(A,B : integer;aProc :  TMyProcedureType);

begin
  aProc(4*A,2*B)
end;

Type
  TMyPrecisionImpl = class(TInterfacedObject, TMyProcedureType)
     Prec: LongInt;
     DoPlus : Boolean;
     procedure Invoke(X,Y: integer);
  end;

procedure TMyPrecisionImpl.Invoke(X,Y : Integer);

begin
  if DoPlus then
    writeln(X:Prec,'+',Y:prec,'=',(X+Y):Prec)
  else
    writeln(X:prec,'-',Y:prec,'=',(X-Y):prec)
end;

procedure DoIt;

var
   P : TMyPrecisionImpl;
   F : TMyProcedureType;
   
begin
   P:=TMyPrecisionImpl.Create;
   F:=P;
   P.Prec:=3;
   P.Doplus:=True;
   ExecProcedure(10,20,F);
   P.Prec:=5;
   P.DoPlus:=False;
   ExecProcedure(10,20,f);
   F:=Nil;
end;

begin
  DoIt;   
end.
